]> git.ipfire.org Git - thirdparty/kernel/linux.git/blob - scripts/link-vmlinux.sh
Merge tag 'pm-6.9-rc3' of git://git.kernel.org/pub/scm/linux/kernel/git/rafael/linux-pm
[thirdparty/kernel/linux.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7 # vmlinux.a contains objects that are linked unconditionally.
8 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9 # (not within --whole-archive), and do not require symbol indexes added.
10 #
11 # vmlinux
12 # ^
13 # |
14 # +--< vmlinux.a
15 # |
16 # +--< $(KBUILD_VMLINUX_LIBS)
17 # | +--< lib/lib.a + more
18 # |
19 # +-< ${kallsymso} (see description in KALLSYMS section)
20 #
21 # vmlinux version (uname -v) cannot be updated during normal
22 # descending-into-subdirs phase since we do not yet know if we need to
23 # update vmlinux.
24 # Therefore this step is delayed until just before final link of vmlinux.
25 #
26 # System.map is generated to document addresses of all kernel symbols
27
28 # Error out on error
29 set -e
30
31 LD="$1"
32 KBUILD_LDFLAGS="$2"
33 LDFLAGS_vmlinux="$3"
34
35 is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
37 }
38
39 # Nice output in kbuild format
40 # Will be supressed by "make -s"
41 info()
42 {
43 printf " %-7s %s\n" "${1}" "${2}"
44 }
45
46 # Link of vmlinux
47 # ${1} - output file
48 # ${2}, ${3}, ... - optional extra .o files
49 vmlinux_link()
50 {
51 local output=${1}
52 local objs
53 local libs
54 local ld
55 local ldflags
56 local ldlibs
57
58 info LD ${output}
59
60 # skip output file argument
61 shift
62
63 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
64 # Use vmlinux.o instead of performing the slow LTO link again.
65 objs=vmlinux.o
66 libs=
67 else
68 objs=vmlinux.a
69 libs="${KBUILD_VMLINUX_LIBS}"
70 fi
71
72 if is_enabled CONFIG_MODULES; then
73 objs="${objs} .vmlinux.export.o"
74 fi
75
76 objs="${objs} init/version-timestamp.o"
77
78 if [ "${SRCARCH}" = "um" ]; then
79 wl=-Wl,
80 ld="${CC}"
81 ldflags="${CFLAGS_vmlinux}"
82 ldlibs="-lutil -lrt -lpthread"
83 else
84 wl=
85 ld="${LD}"
86 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
87 ldlibs=
88 fi
89
90 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
91
92 # The kallsyms linking does not need debug symbols included.
93 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
94 ldflags="${ldflags} ${wl}--strip-debug"
95 fi
96
97 if is_enabled CONFIG_VMLINUX_MAP; then
98 ldflags="${ldflags} ${wl}-Map=${output}.map"
99 fi
100
101 ${ld} ${ldflags} -o ${output} \
102 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
103 ${wl}--start-group ${libs} ${wl}--end-group \
104 $@ ${ldlibs}
105 }
106
107 # generate .BTF typeinfo from DWARF debuginfo
108 # ${1} - vmlinux image
109 # ${2} - file to dump raw BTF data into
110 gen_btf()
111 {
112 local pahole_ver
113
114 if ! [ -x "$(command -v ${PAHOLE})" ]; then
115 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
116 return 1
117 fi
118
119 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
120 if [ "${pahole_ver}" -lt "116" ]; then
121 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
122 return 1
123 fi
124
125 vmlinux_link ${1}
126
127 info "BTF" ${2}
128 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
129
130 # Create ${2} which contains just .BTF section but no symbols. Add
131 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132 # deletes all symbols including __start_BTF and __stop_BTF, which will
133 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
134 # objcopy warnings: "empty loadable segment detected at ..."
135 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136 --strip-all ${1} ${2} 2>/dev/null
137 # Change e_type to ET_REL so that it can be used to link final vmlinux.
138 # GNU ld 2.35+ and lld do not allow an ET_EXEC input.
139 if is_enabled CONFIG_CPU_BIG_ENDIAN; then
140 et_rel='\0\1'
141 else
142 et_rel='\1\0'
143 fi
144 printf "${et_rel}" | dd of=${2} conv=notrunc bs=1 seek=16 status=none
145 }
146
147 # Create ${2} .S file with all symbols from the ${1} object file
148 kallsyms()
149 {
150 local kallsymopt;
151
152 if is_enabled CONFIG_KALLSYMS_ALL; then
153 kallsymopt="${kallsymopt} --all-symbols"
154 fi
155
156 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
157 kallsymopt="${kallsymopt} --absolute-percpu"
158 fi
159
160 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
161 kallsymopt="${kallsymopt} --base-relative"
162 fi
163
164 if is_enabled CONFIG_LTO_CLANG; then
165 kallsymopt="${kallsymopt} --lto-clang"
166 fi
167
168 info KSYMS ${2}
169 scripts/kallsyms ${kallsymopt} ${1} > ${2}
170 }
171
172 # Perform one step in kallsyms generation, including temporary linking of
173 # vmlinux.
174 kallsyms_step()
175 {
176 kallsymso_prev=${kallsymso}
177 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
178 kallsymso=${kallsyms_vmlinux}.o
179 kallsyms_S=${kallsyms_vmlinux}.S
180
181 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
182 mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms ${kallsymso_prev}
183 kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
184
185 info AS ${kallsyms_S}
186 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
187 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
188 -c -o ${kallsymso} ${kallsyms_S}
189 }
190
191 # Create map file with all symbols from ${1}
192 # See mksymap for additional details
193 mksysmap()
194 {
195 info NM ${2}
196 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2} ${3}
197 }
198
199 sorttable()
200 {
201 ${objtree}/scripts/sorttable ${1}
202 }
203
204 # Delete output files in case of error
205 cleanup()
206 {
207 rm -f .btf.*
208 rm -f System.map
209 rm -f vmlinux
210 rm -f vmlinux.map
211 }
212
213 # Use "make V=1" to debug this script
214 case "${KBUILD_VERBOSE}" in
215 *1*)
216 set -x
217 ;;
218 esac
219
220 if [ "$1" = "clean" ]; then
221 cleanup
222 exit 0
223 fi
224
225 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
226
227 btf_vmlinux_bin_o=""
228 if is_enabled CONFIG_DEBUG_INFO_BTF; then
229 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
230 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
231 echo >&2 "Failed to generate BTF for vmlinux"
232 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
233 exit 1
234 fi
235 fi
236
237 kallsymso=""
238 kallsymso_prev=""
239 kallsyms_vmlinux=""
240 if is_enabled CONFIG_KALLSYMS; then
241
242 # kallsyms support
243 # Generate section listing all symbols and add it into vmlinux
244 # It's a three step process:
245 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
246 # but __kallsyms is empty.
247 # Running kallsyms on that gives us .tmp_kallsyms1.o with
248 # the right size
249 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
250 # the right size, but due to the added section, some
251 # addresses have shifted.
252 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
253 # 3) That link may have expanded the kernel image enough that
254 # more linker branch stubs / trampolines had to be added, which
255 # introduces new names, which further expands kallsyms. Do another
256 # pass if that is the case. In theory it's possible this results
257 # in even more stubs, but unlikely.
258 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
259 # other bugs.
260 # 4) The correct ${kallsymso} is linked into the final vmlinux.
261 #
262 # a) Verify that the System.map from vmlinux matches the map from
263 # ${kallsymso}.
264
265 kallsyms_step 1
266 kallsyms_step 2
267
268 # step 3
269 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
270 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
271
272 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
273 kallsyms_step 3
274 fi
275 fi
276
277 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
278
279 # fill in BTF IDs
280 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
281 info BTFIDS vmlinux
282 ${RESOLVE_BTFIDS} vmlinux
283 fi
284
285 mksysmap vmlinux System.map ${kallsymso}
286
287 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
288 info SORTTAB vmlinux
289 if ! sorttable vmlinux; then
290 echo >&2 Failed to sort kernel tables
291 exit 1
292 fi
293 fi
294
295 # step a (see comment above)
296 if is_enabled CONFIG_KALLSYMS; then
297 if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
298 echo >&2 Inconsistent kallsyms data
299 echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
300 exit 1
301 fi
302 fi
303
304 # For fixdep
305 echo "vmlinux: $0" > .vmlinux.d